from .imageprotocol import ImageProtocol

proto: str = 'https://'
ai: str = '.ai/prompt/'

def resource(deprecated: bool=False):
  def decorator(func):
    func.deprecated: bool = deprecated
    return func
  return decorator

@resource(deprecated=False)
class ImageObject(ImageProtocol):
  def __init__(self, prompt: str, url: str, date: str, content: bin, *args, **kwargs) -> None:
      self.prompt: str = prompt
      self.url: str = url
      self.date: str = date
      self.content: bin = content

  def __repr__(self, *args, **kwargs) -> str:
      return f"ImageObject(prompt={self.prompt}, date={self.date}, url={self.url}, content={len(self.content)})"


samples = [
  "Cat",
  "Sunset",
  "Tree",
  "Abstract art",
  "Beach landscape",
  "City skyline at night",
  "Vintage car",
  "Mystical forest",
  "Rainy day",
  "Mountain peak",
  "Underwater world",
  "Family portrait",
  "Space exploration",
  "Dreamy clouds",
  "Autumn foliage",
  "Urban street scene",
  "Ancient ruins",
  "Endless desert",
  "Tropical paradise",
  "Fantasy castle",
  "Abstract patterns",
  "Ocean waves",
  "Garden flowers",
  "Fireworks display",
  "Snowy mountain range",
  "Wildlife safari",
  "Futuristic cityscape",
  "Countryside farmhouse",
  "Waterfall in the jungle",
  "Still life with fruits",
  "Industrial machinery",
  "Magical fairy tale",
  "Sports action shot",
  "Haunted house",
  "Vintage portrait",
  "Nighttime city traffic",
  "Majestic eagle",
  "Rainbow over a meadow",
  "Steampunk-inspired scene",
  "Cute puppies and kittens",
  "Abstract geometric shapes",
  "Artificial intelligence",
  "Dramatic storm clouds",
  "Historical landmarks",
  "Colorful hot air balloons",
  "Rural farm landscape",
  "Reflections on water",
  "Gloomy cemetery",
  "Astronaut in space",
  "Abstract surrealism",
  "Starry night sky",
  "Serene lakeside view",
  "Vibrant city market",
  "Rustic country barn",
  "Enchanted forest pathway",
  "Majestic waterfall",
  "Whimsical fairytale cottage",
  "Dramatic thunderstorm",
  "Tropical island getaway",
  "Abstract mixed media",
  "Ancient temple ruins",
  "Tranquil river scene",
  "Playful dolphins in the ocean",
  "Dynamic urban graffiti",
  "Peaceful zen garden",
  "Cozy winter cabin",
  "Vibrant floral still life",
  "Exotic bird of paradise",
  "Futuristic spaceship interior",
  "Lush green meadow",
  "Charming seaside",
  "Space exploration",
  "Dreamy clouds",
  "Autumn foliage",
  "Urban street scene",
  "Ancient ruins",
  "Endless desert",
  "Tropical paradise",
  "Fantasy castle",
  "Abstract patterns",
  "Ocean waves",
  "Garden flowers",
  "Fireworks display",
  "Snowy mountain range",
  "Wildlife safari",
  "Futuristic cityscape",
  "Countryside farmhouse",
  "Waterfall in the jungle",
  "Still life with fruits",
  "Industrial machinery",
  "Magical fairy tale",
  "Sports action shot",
  "Haunted house",
  "Vintage portrait",
  "Nighttime city traffic",
  "Majestic eagle",
  "Rainbow over a meadow",
  "Steampunk-inspired scene",
  "Cute puppies and kittens",
  "Abstract geometric shapes",
  "Artificial intelligence",
  "Dramatic storm clouds",
  "Historical landmarks",
  "Colorful hot air balloons",
  "Rural farm landscape",
  "Reflections on water",
  "Gloomy cemetery",
  "Astronaut in space",
  "Abstract surrealism",
  "Starry night sky",
  "Serene lakeside view",
  "Vibrant city market",
  "Rustic country barn",
  "Enchanted forest pathway",
  "Majestic waterfall",
  "Whimsical fairytale cottage",
  "Dramatic thunderstorm",
  "Tropical island getaway",
  "Abstract mixed media",
  "Ancient temple ruins",
  "Tranquil river scene",
  "Playful dolphins in the ocean",
  "Dynamic urban graffiti",
  "Peaceful zen garden",
  "Cozy winter cabin",
  "Vibrant floral still life",
  "Exotic bird of paradise",
  "Futuristic spaceship interior",
  "Lush green meadow",
  "Charming seaside",
  "Sunflower field",
  "Misty morning landscape",
  "Abstract expressionism",
  "Rugged mountain terrain",
  "Enigmatic black and white",
  "Tropical rainforest",
  "Surreal dream sequence",
  "Vintage cityscape",
  "Whale underwater",
  "Festive holiday scene",
  "Vibrant butterfly collection",
  "Majestic lion portrait",
  "Cosmic galaxy",
  "Rural vineyard",
  "Abstract minimalism",
  "Golden sunset",
  "Architectural marvel",
  "Mysterious foggy forest",
  "Underground subway station",
  "Delicate flower petals",
  "Urban skateboarding culture",
  "Majestic snowy owl",
  "Abstract cubism",
  "Sailing boat on open water",
  "Bustling marketplace",
  "Vivid autumn colors",
  "Majestic horse running",
  "Abstract fluid art",
  "Aerial view of city lights",
  "Peaceful lakeside cabin",
  "Diverse multicultural community",
  "Mesmerizing light trails",
  "Whimsical hot air balloon festival",
  "Vintage vinyl record collection",
  "Urban parkour stunts",
  "Mystical mermaid underwater",
  "Abstract pop art",
  "Cascading waterfall",
  "Rural wheat field",
  "Abstract digital landscape",
  "Sunrise over the mountains",
  "Dynamic breakdancing performance",
  "Majestic castle on a hill",
  "Abstract collage",
  "Serenity of a bonsai tree",
  "Urban exploration of abandoned buildings",
  "Colorful macaw parrot",
  "Ancient hieroglyphs",
  "Abstract surreal portrait",
  "Picturesque lighthouse",
  "Cosmic nebula",
  "Vintage retro fashion",
  "Peaceful countryside cottage",
  "Abstract kinetic sculpture",
  "Majestic white tiger",
  "Street art murals",
  "Rustic wooden bridge",
  "Abstract fractal patterns",
  "Horseback riding on the beach",
  "Enchanting moonlit night",
  "Lively summer music festival",
  "Abstract wireframe architecture",
  "Vibrant autumn harvest",
  "Spectacular aerial fireworks",
  "Mystical dragon in flight",
  "Abstract neon lights",
  "Antique pocket watch",
  "Urban city cycling",
  "Majestic ancient oak tree",
  "Abstract impressionism",
  "Dynamic roller coaster ride",
  "Peaceful riverside picnic",
  "Whimsical circus performance",
  "Abstract origami sculpture",
  "Picturesque countryside windmill",
  "Tropical island hammock retreat",
  "Abstract calligraphy",
  "Serene waterfall oasis",
  "Vibrant Indian street market",
]